SystemOrganization addCategory: #'Phidget-VMMaker-Plugins'!
SystemOrganization addCategory: #Phidget!
SystemOrganization addCategory: #'Phidget-Core'!
SystemOrganization addCategory: #'Phidget-Lab'!
SystemOrganization addCategory: #'Phidget-Tests'!

TestCase subclass: #PhidgetPluginTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Tests'!

!PhidgetPluginTest methodsFor: 'as yet unclassified' stamp: 'sp 4/26/2009 13:21'!
testTest

	"Hier soll ohne Vorbedingungen getestet werden wie getestet wird ;)"
	^ true! !

SmartSyntaxInterpreterPlugin subclass: #PhidgetPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-VMMaker-Plugins'!

!PhidgetPlugin class methodsFor: 'as yet unclassified' stamp: 'pt 4/6/2009 17:20'!
hasHeaderFile
	"If there is a single intrinsic header file to be associated with the plugin, here is where you want to flag"
	^true! !

!PhidgetPlugin class methodsFor: 'as yet unclassified' stamp: 'pt 4/18/2009 17:58'!
requiresCrossPlatformFiles
	"default is ok for most, any plugin needing platform specific files must say so"
	^true! !

!PhidgetPlugin class methodsFor: 'as yet unclassified' stamp: 'pt 4/18/2009 17:57'!
requiresPlatformFiles
	"this plugin requires platform specific files in order to work"
	^true! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'sp 4/26/2009 13:03'!
ifKitValueOf: oop
	"Return a pointer to the first byte of the Phidget_ifKit record within the given Smalltalk bytes object, or nil if oop is not a Phidget_ifKit record."

	self returnTypeC: 'Phidget_ifKit *'.
	interpreterProxy success:
		( ( interpreterProxy isIntegerObject: oop ) not and:
		 [ ( interpreterProxy isBytes: oop ) and:
		 [ ( interpreterProxy slotSizeOf: oop ) = ( self cCode: 'sizeof(Phidget_ifKit)' ) ] ] ).
	interpreterProxy failed ifTrue: [^ nil].
	^ self cCode: '(Phidget_ifKit *) (oop + 4)'! !

!PhidgetPlugin methodsFor: 'Plugin common' stamp: 'sp 4/26/2009 13:03'!
initialiseModule
	"Initialise the module"

	self export: true.
	^ self cCode: '(sqInt) phidgetPlugin_Initialise()' inSmalltalk: [true]! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'sp 4/26/2009 13:04'!
phidgetValueOf: oop
	"Return a pointer to the first byte of the Phidget record within the given Smalltalk bytes object, or nil if oop is not a Phidget record."

	self returnTypeC: 'Phidget *'.
	interpreterProxy success:
		( ( interpreterProxy isIntegerObject: oop ) not and:
		 [ ( interpreterProxy isBytes: oop ) and:
		 [ ( interpreterProxy slotSizeOf: oop ) = ( self cCode: 'sizeof(Phidget)' ) ] ] ).
	interpreterProxy failed ifTrue: [^ nil].
	^ self cCode: '(Phidget *) (oop + 4)'! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'sp 4/26/2009 13:05'!
primIfKitAttached: ifKitHandle

	| phid |
	self var: #phid type: 'Phidget_ifKit *'.
	self primitive: 'primIfKitAttached' parameters: #(Oop ).
	phid := self ifKitValueOf: ifKitHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidget_Attached((Phidget *)phid)' )! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'pt 4/27/2009 20:45'!
primIfKitClose: phidHandle

	| phid |
	self var: #phid type: 'Phidget_ifKit *'.
	self primitive: 'primIfKitClose' parameters: #(Oop ).
	phid := self ifKitValueOf: phidHandle.
	^ self cCode: 'phidgetIfKit_Close(phid)'! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'sp 4/26/2009 13:07'!
primIfKitCreate

	| phidOop phid |
	self var: #phid type: 'Phidget_ifKit *'.
	self primitive: 'primIfKitCreate' parameters: #( ).
	
	phidOop := interpreterProxy instantiateClass: interpreterProxy 
		classByteArray indexableSize: ( self cCode: 'sizeof(Phidget_ifKit)' ).
	phid := self ifKitValueOf: phidOop.
	interpreterProxy failed ifFalse: [ self cCode: 'phidgetIfKit_ResetSemaphores(phid)' ].
	^ phidOop! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'pt 4/28/2009 07:53'!
primIfKitNumInput: phidHandle

	| phid |
	self var: #phid type: 'Phidget_ifKit *'.
	self primitive: 'primIfKitNumInput' parameters: #(Oop ).
	
	phid := self ifKitValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetIfKit_NumInput(phid)' )! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'pt 4/28/2009 07:53'!
primIfKitNumOutput: phidHandle

	| phid |
	self var: #phid type: 'Phidget_ifKit *'.
	self primitive: 'primIfKitNumOutput' parameters: #(Oop ).
	
	phid := self ifKitValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetIfKit_NumOutput(phid)' )! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'pt 4/28/2009 07:54'!
primIfKitNumSensors: phidHandle

	| phid |
	self var: #phid type: 'Phidget_ifKit *'.
	self primitive: 'primIfKitNumSensors' parameters: #(Oop ).
	
	phid := self ifKitValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetIfKit_NumSensors(phid)' )! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'sp 4/26/2009 13:07'!
primIfKitOnAttach: phidHandle SemaphoreIndex: semaIndex

	| phid |
	self var: #phid type: 'Phidget_ifKit *'.
	self primitive: 'primIfKitOnAttach' parameters: #(Oop SmallInteger ).
	
	phid := self ifKitValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidget_SetOnAttachSemaIndex((Phidget *)phid, (int)semaIndex)' )! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'sp 4/26/2009 13:08'!
primIfKitOnDetach: phidHandle SemaphoreIndex: semaIndex

	| phid |
	self var: #phid type: 'Phidget_ifKit *'.
	self primitive: 'primIfKitOnDetach' parameters: #(Oop SmallInteger ).

	phid := self ifKitValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidget_SetOnDetachSemaIndex((Phidget *)phid, (int)semaIndex)' )! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'sp 4/26/2009 13:08'!
primIfKitOnError: phidHandle SemaphoreIndex: semaIndex

	| phid |
	self var: #phid type: 'Phidget_ifKit *'.
	self primitive: 'primIfKitOnError' parameters: #(Oop SmallInteger ).
	
	phid := self ifKitValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidget_SetOnErrorSemaIndex((Phidget *)phid, (int)semaIndex)' )! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'sp 4/26/2009 13:09'!
primIfKitOnInputChange: phidHandle SemaphoreIndex: semaIndex

	| phid |
	self var: #phid type: 'Phidget_ifKit *'.
	self primitive: 'primIfKitOnInputChange' parameters: #(Oop SmallInteger ).
	
	phid := self ifKitValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetIfKit_SetOnInputChangeSemaIndex(phid, (int)semaIndex)' )! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'sp 4/26/2009 13:10'!
primIfKitOnOutputChange: phidHandle SemaphoreIndex: semaIndex

	| phid |
	self var: #phid type: 'Phidget_ifKit *'.
	self primitive: 'primIfKitOnOutputChange' parameters: #(Oop SmallInteger ).
	
	phid := self ifKitValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetIfKit_SetOnOutputChangeSemaIndex(phid, (int)semaIndex)' )! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'pt 4/22/2009 14:21'!
primIfKitOnSensorChange: phidHandle SemaphoreIndex: semaIndex
	| phid |
	self var: #phid type: 'Phidget_ifKit *'.
	self primitive: 'primIfKitOnSensorChange' parameters: #(Oop SmallInteger ).
	
	phid := self ifKitValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: (self cCode: 'phidgetIfKit_SetOnSensorChangeSemaIndex(phid, (int)semaIndex)')! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'sp 4/26/2009 13:12'!
primIfKitOpen: phidOop withSerial: serial

	| phid |
	self var: #phid type: 'Phidget_ifKit *'.
	self primitive: 'primIfKitOpen' parameters: #(Oop SmallInteger ).
	
	phid := self ifKitValueOf: phidOop.
	interpreterProxy failed ifFalse: [ self cCode: 'phidgetIfKit_Open(phid, (int)serial)' ].
	^ phidOop! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'sp 4/26/2009 13:12'!
primIfKitOpenAny: phidOop

	| phid |
	self var: #phid type: 'Phidget_ifKit *'.
	self primitive: 'primIfKitOpenAny' parameters: #(Oop ).
	
	phid := self ifKitValueOf: phidOop.
	interpreterProxy failed ifFalse: [ self cCode: 'phidgetIfKit_OpenAny(phid)' ].
	^ phidOop! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'pt 4/28/2009 07:54'!
primIfKitSensorValue: phidHandle at: index

	| phid |
	self var: #phid type: 'Phidget_ifKit *'.
	self primitive: 'primIfKitSensorValue' parameters: #(Oop SmallInteger ).
	
	phid := self ifKitValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetIfKit_GetSensorValue(phid, (int)index)' )! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'sp 4/26/2009 13:20'!
primLastError

	self primitive: 'primLastError' parameters: #( ).
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidget_LastError()' )! !

!PhidgetPlugin methodsFor: 'Servo' stamp: 'pt 4/27/2009 21:12'!
primServoAttached: servoHandle

	| phid |
	self var: #phid type: 'Phidget_servo *'.
	self primitive: 'primServoAttached' parameters: #(Oop ).
	phid := self servoValueOf: servoHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidget_Attached((Phidget *)phid)' )! !

!PhidgetPlugin methodsFor: 'Servo' stamp: 'pt 4/28/2009 09:25'!
primServoClose: phidHandle

	| phid |
	self var: #phid type: 'Phidget_servo *'.
	self primitive: 'primServoClose' parameters: #(Oop ).
	phid := self servoValueOf: phidHandle.
	^ self cCode: 'phidgetServo_Close(phid)'! !

!PhidgetPlugin methodsFor: 'Servo' stamp: 'pt 4/27/2009 21:11'!
primServoCreate

	| phidOop phid |
	self var: #phid type: 'Phidget_servo *'.
	self primitive: 'primServoCreate' parameters: #( ).
	
	phidOop := interpreterProxy instantiateClass: interpreterProxy 
		classByteArray indexableSize: ( self cCode: 'sizeof(Phidget_servo)' ).
	phid := self servoValueOf: phidOop.
	interpreterProxy failed ifFalse: [ self cCode: 'phidgetServo_ResetSemaphores(phid)' ].
	^ phidOop! !

!PhidgetPlugin methodsFor: 'Servo' stamp: 'pt 4/28/2009 09:32'!
primServoGetEngaged: servoHandle at: index

	| phid |
	self var: #phid type: 'Phidget_servo *'.
	self primitive: 'primServoGetEngaged' parameters: #(Oop SmallInteger).
	phid := self servoValueOf: servoHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetServo_GetEngaged(phid, (int)index)' )! !

!PhidgetPlugin methodsFor: 'Servo' stamp: 'pt 4/28/2009 09:22'!
primServoGetMotorPosition: phidHandle at: index

	| phid |
	self var: #phid type: 'Phidget_servo *'.
	self primitive: 'primServoGetMotorPosition' parameters: #(Oop SmallInteger ).
	
	phid := self servoValueOf: phidHandle.
	^ interpreterProxy floatObjectOf: ( self cCode: 'phidgetServo_GetPosition(phid, (int)index)' )! !

!PhidgetPlugin methodsFor: 'Servo' stamp: 'pt 4/28/2009 09:21'!
primServoGetMotorPositionMax: phidHandle at: index

	| phid |
	self var: #phid type: 'Phidget_servo *'.
	self primitive: 'primServoGetMotorPositionMax' parameters: #(Oop SmallInteger ).
	
	phid := self servoValueOf: phidHandle.
	^ interpreterProxy floatObjectOf: ( self cCode: 'phidgetServo_GetPositionMax(phid, (int)index)' )! !

!PhidgetPlugin methodsFor: 'Servo' stamp: 'pt 4/28/2009 09:22'!
primServoGetMotorPositionMin: phidHandle at: index

	| phid |
	self var: #phid type: 'Phidget_servo *'.
	self primitive: 'primServoGetMotorPositionMin' parameters: #(Oop SmallInteger ).
	
	phid := self servoValueOf: phidHandle.
	^ interpreterProxy floatObjectOf: ( self cCode: 'phidgetServo_GetPositionMin(phid, (int)index)' )! !

!PhidgetPlugin methodsFor: 'Servo' stamp: 'pt 4/28/2009 07:39'!
primServoNumMotors: servoHandle

	| phid |
	self var: #phid type: 'Phidget_servo *'.
	self primitive: 'primServoNumMotors' parameters: #(Oop ).
	phid := self servoValueOf: servoHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetServo_NumMotors(phid)' )! !

!PhidgetPlugin methodsFor: 'Servo' stamp: 'pt 4/28/2009 09:29'!
primServoOnAttach: phidHandle SemaphoreIndex: semaIndex 
	| phid |
	self 
		var: #phid
		type: 'Phidget_servo *'.
	self 
		primitive: 'primServoOnAttach'
		parameters: #(#Oop #SmallInteger ).
	phid := self servoValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: (self cCode: 'phidget_SetOnAttachSemaIndex((Phidget *)phid, (int)semaIndex)')! !

!PhidgetPlugin methodsFor: 'Servo' stamp: 'pt 4/27/2009 21:10'!
primServoOnDetach: phidHandle SemaphoreIndex: semaIndex

	| phid |
	self var: #phid type: 'Phidget_servo *'.
	self primitive: 'primServoOnDetach' parameters: #(Oop SmallInteger ).

	phid := self servoValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidget_SetOnDetachSemaIndex((Phidget *)phid, (int)semaIndex)' )! !

!PhidgetPlugin methodsFor: 'Servo' stamp: 'pt 4/27/2009 21:10'!
primServoOnError: phidHandle SemaphoreIndex: semaIndex

	| phid |
	self var: #phid type: 'Phidget_servo *'.
	self primitive: 'primServoOnError' parameters: #(Oop SmallInteger ).
	
	phid := self servoValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidget_SetOnErrorSemaIndex((Phidget *)phid, (int)semaIndex)' )! !

!PhidgetPlugin methodsFor: 'Servo' stamp: 'pt 4/27/2009 21:08'!
primServoOnPositionChange: phidHandle SemaphoreIndex: semaIndex

	| phid |
	self var: #phid type: 'Phidget_servo *'.
	self primitive: 'primServoOnPositionChange' parameters: #(Oop SmallInteger ).
	
	phid := self servoValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetServo_SetOnPositionChangeSemaIndex(phid, (int)semaIndex)' )! !

!PhidgetPlugin methodsFor: 'Servo' stamp: 'pt 4/27/2009 21:13'!
primServoOpen: phidOop withSerial: serial

	| phid |
	self var: #phid type: 'Phidget_servo *'.
	self primitive: 'primServoOpen' parameters: #(Oop SmallInteger ).
	
	phid := self servoValueOf: phidOop.
	interpreterProxy failed ifFalse: [ self cCode: 'phidgetServo_Open(phid, (int)serial)' ].
	^ phidOop! !

!PhidgetPlugin methodsFor: 'Servo' stamp: 'pt 4/27/2009 21:14'!
primServoOpenAny: phidOop

	| phid |
	self var: #phid type: 'Phidget_servo *'.
	self primitive: 'primServoOpenAny' parameters: #(Oop ).
	
	phid := self servoValueOf: phidOop.
	interpreterProxy failed ifFalse: [ self cCode: 'phidgetServo_OpenAny(phid)' ].
	^ phidOop! !

!PhidgetPlugin methodsFor: 'Servo' stamp: 'pt 4/28/2009 09:28'!
primServoSetEngaged: servoHandle at: index to: value

	| phid |
	self var: #phid type: 'Phidget_servo *'.
	self primitive: 'primServoSetEngaged' parameters: #(Oop SmallInteger SmallInteger ).
	
	interpreterProxy success: (value<=1 and: [ value >=0 ]).
	interpreterProxy failed ifTrue: [^ nil].
	phid := self servoValueOf: servoHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetServo_SetEngaged(phid, (int)index, value)' )! !

!PhidgetPlugin methodsFor: 'Servo' stamp: 'pt 4/28/2009 08:05'!
primServoSetMotorPosition: phidHandle at: index to: value

	| phid floatValue |
	self var: #phid type: 'Phidget_servo *'.
	self var: #floatValue type: 'double'.
	self primitive: 'primServoSetMotorPosition' parameters: #(Oop SmallInteger Oop ).
	
	phid := self servoValueOf: phidHandle.
	floatValue := interpreterProxy floatValueOf: value.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetServo_SetPosition(phid, (int)index, floatValue)' )! !

!PhidgetPlugin methodsFor: 'Servo' stamp: 'pt 4/27/2009 20:41'!
servoValueOf: oop
	"Return a pointer to the first byte of the Phidget_servo record within the given Smalltalk bytes object, or nil if oop is not a Phidget_servo record."

	self returnTypeC: 'Phidget_servo *'.
	interpreterProxy success:
		( ( interpreterProxy isIntegerObject: oop ) not and:
		 [ ( interpreterProxy isBytes: oop ) and:
		 [ ( interpreterProxy slotSizeOf: oop ) = ( self cCode: 'sizeof(Phidget_servo)' ) ] ] ).
	interpreterProxy failed ifTrue: [^ nil].
	^ self cCode: '(Phidget_servo *) (oop + 4)'! !

!PhidgetPlugin methodsFor: 'Plugin common' stamp: 'sp 4/26/2009 13:20'!
shutdownModule
	"Shutdown the module"
	
	self export: true.
	^ self cCode: '(sqInt) phidgetPlugin_Shutdown()' inSmalltalk: [true]! !

Object subclass: #PhdCrPhidget
	instanceVariableNames: 'semaphores processBlocks opened'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

PhdCrPhidget subclass: #PhdCrInterfaceKit
	instanceVariableNames: 'ifKit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'sp 4/26/2009 12:44'!
close
	"close the interfaceKit Phidget"

	opened ifFalse: [^ self]. "already closed"
	self primClose: ifKit.
	opened := false.
	self unregisterSemaphores.! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'sp 4/26/2009 12:45'!
initialize

	super initialize.
	semaphores
		add: #SensorChange->Semaphore new;
		add: #InputChange->Semaphore new;
		add: #OutputChange->Semaphore new.
		
	processBlocks
		add: #SensorChange->[];
		add: #InputChange->[];
		add: #OutputChange->[].
		
	opened := false.
	ifKit := self primCreate.! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'sp 4/26/2009 12:45'!
onInputChangeDo: aBlock

	processBlocks at: #InputChange put: aBlock.! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'sp 4/26/2009 12:45'!
onOutputChangeDo: aBlock

	processBlocks at: #OutputChange put: aBlock.! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'sp 4/26/2009 12:45'!
onSensorChangeDo: aBlock

	processBlocks at: #SensorChange put: aBlock.! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'sp 4/26/2009 12:48'!
openAny
	"opens any InterfaceKit Phidget"
	
	ifKit ifNil: [ self error: 'Could not open InterfaceKit!!'. ^ self ].
	self registerSemaphores.
	self primOpenAny: ifKit.
	opened := true.
	[ self callbackProcess: #Attach ] fork.
	[ self callbackProcess: #Detach ] fork.
	[ self callbackProcess: #Error ] fork.
	[ self callbackProcess: #SensorChange ] fork.
	[ self callbackProcess: #InputChange ] fork.
	[ self callbackProcess: #OutputChange ] fork.! !

!PhdCrInterfaceKit methodsFor: 'primitives' stamp: 'sp 4/26/2009 12:49'!
primClose: phid
	"close the interfaceKit Phidget"
	
	<primitive: 'primIfKitClose' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrInterfaceKit methodsFor: 'primitives' stamp: 'sp 4/26/2009 12:49'!
primCreate
	"reset the interfaceKit Phidget (Semaphores and Handle)"

	<primitive: 'primIfKitCreate' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrInterfaceKit methodsFor: 'primitives' stamp: 'sp 4/26/2009 12:49'!
primOnAttach: phid SemaphoreIndex: semaIndex
	"registers the given Semaphore to be signaled when a SensorValue changed."
	
	<primitive: 'primIfKitOnAttach' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrInterfaceKit methodsFor: 'primitives' stamp: 'sp 4/26/2009 12:49'!
primOnDetach: phid SemaphoreIndex: semaIndex
	"registers the given Semaphore to be signaled when a SensorValue changed."
	
	<primitive: 'primIfKitOnDetach' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrInterfaceKit methodsFor: 'primitives' stamp: 'sp 4/26/2009 12:49'!
primOnError: phid SemaphoreIndex: semaIndex
	"registers the given Semaphore to be signaled when a SensorValue changed."
	
	<primitive: 'primIfKitOnError' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrInterfaceKit methodsFor: 'primitives' stamp: 'sp 4/26/2009 12:49'!
primOnInputChange: phid SemaphoreIndex: semaIndex
	"registers the given Semaphore to be signaled when a SensorValue changed."
	
	<primitive: 'primIfKitOnInputChange' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrInterfaceKit methodsFor: 'primitives' stamp: 'sp 4/26/2009 12:50'!
primOnOutputChange: phid SemaphoreIndex: semaIndex
	"registers the given Semaphore to be signaled when a SensorValue changed."
	
	<primitive: 'primIfKitOnOutputChange' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrInterfaceKit methodsFor: 'primitives' stamp: 'sp 4/26/2009 12:50'!
primOnSensorChange: phid SemaphoreIndex: semaIndex
	"registers the given Semaphore to be signaled when a SensorValue changed."
	
	<primitive: 'primIfKitOnSensorChange' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrInterfaceKit methodsFor: 'primitives' stamp: 'sp 4/26/2009 12:50'!
primOpen: phid withSerial: serial
	"opens the phidget with the given serialNumber InterfaceKit Phidget"

	<primitive: 'primIfKitOpen' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrInterfaceKit methodsFor: 'primitives' stamp: 'sp 4/26/2009 12:50'!
primOpenAny: phid
	"opens any available InterfaceKit Phidget"

	<primitive: 'primIfKitOpenAny' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrInterfaceKit methodsFor: 'primitives' stamp: 'sp 4/26/2009 12:50'!
primSensorValue: phid At: sensorIndex
	"gets the sensor value (0-1000) at the analog input with the given index"

	<primitive: 'primIfKitSensorValue' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'sp 4/26/2009 12:57'!
registerSemaphores

	| semaIndex |
	semaIndex := Smalltalk registerExternalObject: ( semaphores at:#SensorChange ).
	self primOnSensorChange: ifKit SemaphoreIndex: semaIndex.
	semaIndex := Smalltalk registerExternalObject: ( semaphores at:#InputChange ).
	self primOnInputChange: ifKit SemaphoreIndex: semaIndex.
	semaIndex := Smalltalk registerExternalObject: ( semaphores at:#OutputChange ).
	self primOnOutputChange: ifKit SemaphoreIndex: semaIndex.
	semaIndex := Smalltalk registerExternalObject: ( semaphores at:#Attach ).
	self primOnAttach: ifKit SemaphoreIndex: semaIndex.
	semaIndex := Smalltalk registerExternalObject: ( semaphores at:#Detach ).
	self primOnDetach: ifKit SemaphoreIndex: semaIndex.
	semaIndex := Smalltalk registerExternalObject: ( semaphores at:#Error ).
	self primOnError: ifKit SemaphoreIndex: semaIndex.! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'sp 4/26/2009 12:58'!
sensorValue: sensorIndex
	"gets the sensor value (0-1000) at the analog input with the given index"

	sensorIndex >= 1 & sensorIndex <= 8
		ifTrue:[ ^ self primSensorValue: ifKit At: sensorIndex - 1 ].
	^ nil! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'sp 4/26/2009 12:59'!
unregisterSemaphores

	semaphores do: [ :sema |
		sema signal.
		Smalltalk unregisterExternalObject: sema ]! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'sp 4/26/2009 12:42'!
callbackProcess: aSymbol

	( semaphores at: aSymbol ) wait.
	[opened] whileTrue: [
		( processBlocks at: aSymbol ) value.
		( semaphores at: aSymbol ) wait ].! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'sp 4/26/2009 12:43'!
initialize

	super initialize.
	semaphores := Dictionary new.
	semaphores
		add: #Attach->Semaphore new;
		add: #Detach->Semaphore new;
		add: #Error->Semaphore new.
		
	processBlocks := Dictionary new.
	processBlocks
		add: #Attach->[];
		add: #Detach->[];
		add: #Error->[].! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'sp 4/26/2009 12:43'!
lastError

	^ self primLastError! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'sp 4/26/2009 12:43'!
onAttachDo: aBlock

	processBlocks at: #Attach put: aBlock.! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'sp 4/26/2009 12:43'!
onDetachDo: aBlock

	processBlocks at: #Detach put: aBlock.! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'sp 4/26/2009 12:43'!
onErrorDo: aBlock

	processBlocks at: #Error put: aBlock.! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'sp 4/26/2009 12:43'!
primLastError
	"Returns last Error Code"

	<primitive: 'primLastError' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'pt 4/22/2009 16:39'!
registerSemaphores

	self subclassResponsibility.! !

PhdCrPhidget subclass: #PhdCrServo
	instanceVariableNames: 'servo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

BorderedMorph subclass: #PhdLbSlider
	instanceVariableNames: 'pick max min maxValue minValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Lab'!

!PhdLbSlider methodsFor: 'as yet unclassified' stamp: 'sp 4/26/2009 13:00'!
initialize

	super initialize.
	self color: Color blue lighter;
		width: 50;
		height: 200.
	pick := BorderedMorph new.
	pick color: Color black;
		width: 40;
		height: 20.
	self addMorph: pick.
	pick
		left: ( self left + 5 );
		top: ( self top + 5 ).
	min := 0.
	max := ( self bottom - 5 ) - ( self top + 5 ) - pick height.
	minValue := 0.
	maxValue := 100.
	! !

!PhdLbSlider methodsFor: 'as yet unclassified' stamp: 'sp 4/26/2009 13:02'!
rawValue: aNumber
	"0 <= aNumber <= 1000"
	"pick top: self bottom - 5 - pick height - (aNumber/1000*max)."

	pick top: self top + 5 + ( ( 1000 - aNumber ) / 1000 * max ).! !

!PhdLbSlider methodsFor: 'as yet unclassified' stamp: 'sp 4/26/2009 13:26'!
setMin: aSmallNumber andMax: aBigNumber

	minValue := aSmallNumber.
	maxValue := aBigNumber.! !

!PhdLbSlider methodsFor: 'as yet unclassified' stamp: 'sp 4/26/2009 13:40'!
value

	^ ( pick top - self top - 5 ) * maxValue / minValue! !
